CREATE TABLE `tg_users` (
  `user_id` bigint(20) NOT NULL,
  `status` int(1) unsigned NOT NULL,
  `timestamp` int(11) unsigned DEFAULT NULL,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `user_id` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `emails` (
  `md5` varchar(32) NOT NULL,
  `email` varchar(255) DEFAULT NULL,
  `data` json DEFAULT NULL,
  `status` int(10) unsigned NOT NULL,
  `timestamp` int(11) unsigned DEFAULT NULL,
  PRIMARY KEY (`md5`),
  UNIQUE KEY `md5` (`md5`),
  UNIQUE KEY `email` (`email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `mails` (
  `md5_mail` varchar(32) NOT NULL,
  `md5_email` varchar(32) NOT NULL,
  `data` json DEFAULT NULL,
  `status` int(11) NOT NULL,
  `timestamp` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`md5_mail`),
  UNIQUE KEY `md5_mail` (`md5_mail`),
  KEY `md5_email` (`md5_email`),
  CONSTRAINT `key2` FOREIGN KEY (`md5_email`) REFERENCES `emails` (`md5`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tasks_create` (
  `user_id` bigint(20) NOT NULL,
  `status` int(1) unsigned NOT NULL,
  `timestamp` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `user_id` (`user_id`),
  CONSTRAINT `key1` FOREIGN KEY (`user_id`) REFERENCES `tg_users` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `tasks_read` (
  `md5_email` varchar(32) NOT NULL,
  `status` int(1) unsigned NOT NULL,
  `timestamp` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`md5_email`),
  CONSTRAINT `key3` FOREIGN KEY (`md5_email`) REFERENCES `emails` (`md5`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `user_email` (
  `id_user` bigint(20) NOT NULL,
  `md5_email` varchar(32) NOT NULL,
  PRIMARY KEY (`id_user`,`md5_email`),
  UNIQUE KEY `id_user` (`id_user`,`md5_email`),
  UNIQUE KEY `md5_email` (`md5_email`),
  CONSTRAINT `key4` FOREIGN KEY (`id_user`) REFERENCES `tg_users` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `key5` FOREIGN KEY (`md5_email`) REFERENCES `emails` (`md5`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;